<!DOCTYPE html>
<html>

<head>
	<title>31.30 Lucky Dice</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<style>
		.bg-img {
			background-image: url("images/cover.jpg");
			min-height: 100px;
			margin: 5px;
		}
	</style>
</head>

<body>
	<div class="container-fluid">
		<div class="bg-img"></div>
	</div>
	<div class="container">
		<div class="row">
			<div class="col-md-4">
				<div class="row form-group">
					<div class="col-md-12 ">
						<h4>Nhập thông tin của bạn</h4>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-4">
						<label for="username">Username</label>
					</div>
					<div class="col-md-8">
						<input type="text" class="form-control" name="username" id="username">
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-4">
						<label for="firstname">Firstname</label>
					</div>
					<div class="col-md-8">
						<input type="text" class="form-control" name="firstname" id="firstname">
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-4">
						<label for="lastname">Lastname</label>
					</div>
					<div class="col-md-8">
						<input type="text" class="form-control" name="lastname" id="lastname">
					</div>
				</div>
			</div>
			<div class="col-md-4 text-center">
				<div class="row form-group">
					<div class="col-md-12">
						<button id="throw-dice" class="btn btn-success button-width w-75">Ném</button>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-12">
						<img id="img-dice" class="img-thumbnail" src="images/dice.png" alt="Dice">
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-12">
						<p id="p-message"></p>
					</div>
				</div>
			</div>
			<div class="col-md-4 text-center">
				<div class="row form-group">
					<div class="col-md-12">
						<p id="p-voucher">Voucher</p>
						<p id="p-voucher-code">No ID</p>
						<p id="p-voucher-percent">0%</p>
					</div>
				</div>
				<div class="row form-group">
					<div class="col-md-12">
						<img id="img-present" src="images/no-present.jpg" class="img-thumbnail" alt="" width="70%" height="100%">
					</div>
				</div>
			</div>
		</div>
		<div class="row form-group">
			<div class="col-md-12 text-center">
				<button class="btn btn-success">Dice History</button>
				<button class="btn btn-info">Voucher History</button>
				<button class="btn btn-info">Present History</button>
			</div>
		</div>
		<div class="row">
			<div class="col-md-12">
				<table id="table-history" class="table table-striped table-hover">
					<thead>
						<th>Lượt</th>
						<th>Dice</th>
					</thead>
					<tbody id="tbody-history">
					</tbody>
				</table>
			</div>
		</div>
	</div>
</body>
<script>
	// Create const
	const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
	const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
	const gREQUEST_STATUS_OK = 200;
	const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

	// Create user obj
	var gUserObj = {
		firstname: "",
		lastname: "",
		username: ""
	}

	// Access input element
	var gUserName = $("#username");
	var gFirstName = $("#firstname");
	var gLastName = $("#lastname");

	// Access p,img element
	var gPMessage = $("#p-message");
	var gImgDice = $("#img-dice");
	var gPVoucher = $("#p-voucher");
	var gPVoucherCode = $("#p-voucher-code");
	var gPVoucherPercent = $("#p-voucher-percent");
	var gImgPresent = $("#img-present");

	//Access table
	var gTableHistory = $("#table-history");
	var gTableHistoryBody = $("#tbody-history");
	// const gEND_OF_ROW_COL = -1;
	// const gCOL_COUNT_PLAY = 0;
	// const gCOL_RESULT_DICE = 1;

	// Khi nhấn nút Ném thì thực hiện code này
	$(document).ready(function() {
		"use-strict"
		$("#throw-dice").on('click', onBtnThrowDiceClick);
	});

	function onBtnThrowDiceClick() {
		"use-strict"
		// Get input value, pour data into user_obj
		gUserObj.username = gUserName.val();
		gUserObj.firstname = gFirstName.val();
		gUserObj.lastname = gLastName.val();
		
		var vCheck = validateData(gUserObj.username, gUserObj.firstname, gUserObj.lastname);
		if (vCheck) {
			var vXmlHttpDice = new XMLHttpRequest();
			getNewDiceThrow(vXmlHttpDice, gUserObj);
			vXmlHttpDice.onreadystatechange = function () {
				if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
					//Gọi server lấy responseText ghi ra console.log
					console.log(vXmlHttpDice.responseText);
					var vResultObj = JSON.parse(vXmlHttpDice.responseText);
					//Chuyển thành Objects và ghi dữ liệu của object  ra console.log
					console.log(vResultObj);
					//Call function show dice, message, voucher, prize
					showResultAfterThrow(vResultObj);
				}
			}
		}
	}

	// Validate data
	function validateData(paramUserName, paramFirstName, paramLastName) {
		"use-strict"
		var vResult = true;
		if (paramUserName.trim() == "") {
			alert("Chưa nhập username!");
			vResult = false;
		}
		if (paramFirstName.trim() == "") {
			alert("Chưa nhập firstname!");
			vResult = false;
		}
		if (paramLastName.trim() == "") {
			alert("Chưa nhập lastname!");
			vResult = false;
		}
		return vResult;
	}

	// Call API getNewDice
	function getNewDiceThrow(paramXMLHttpDice, paramUserObj) {
		"use-strict"
		paramXMLHttpDice.open("POST", gBASE_URL + "/dice", true);
		paramXMLHttpDice.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
		paramXMLHttpDice.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string
	}

	// Show Dice, message, voucher, prize
	function showResultAfterThrow(paramResultObj) {
		"use-strict"
		gPMessage.empty();
		// change image of dice
		gImgDice.attr("src", "images/" + paramResultObj.dice + ".png");

		// Dice > 4 => congrate msg, else try again next time msg
		if (paramResultObj.dice < 4) {
			gPMessage.html("Chúc bạn may mắn lần sau !!!");
			gImgPresent.attr("src", "images/no-present.jpg");
		} else {
			gPMessage.html("Chúc mừng bạn hãy chơi tiếp lần nữa !!!");
		}

		//Show voucher if have
		if (paramResultObj.voucher == null) {
			gPVoucherCode.empty();
			gPVoucherPercent.empty();
		} else {
			gPVoucherCode.html(paramResultObj.voucher.maVoucher);
			gPVoucherPercent.html(paramResultObj.voucher.phanTramGiamGia + "%");
		}

		//Show prize if have
		if (paramResultObj.prize != null) {
			"use-strict"
			var vImgPrize = "";
			if (paramResultObj.prize == "Mũ") {
				vImgPrize = "hat";
			} else if (paramResultObj.prize == "Áo") {
				vImgPrize = "t-shirt";
			} else if (paramResultObj.prize == "Xe máy") {
				vImgPrize = "xe-may";
			} else if (paramResultObj.prize == "Ô tô") {
				vImgPrize = "car";
			}
			gImgPresent.attr("src", "images/" + vImgPrize + ".jpg");
		}
	}
</script>

</html>